#!/bin/sh
#
# tell us all about a track
#

TUNEBOT_ROOT=XXX-the-tunebot-install-root
source $TUNEBOT_ROOT/settings

ltpawk='
{x=$2}
END{
    if (x=="") {
	print "never"
    } else {
	print substr(x,5,2) "/" substr(x,7,2) "/" substr(x,1,4) " " substr(x,9,2) ":" substr(x,11,2)
    }
}
'

ltrawk='
/REQ/{x=$2;n++}
END{
    if (x=="") {
	print "never"
    } else {
	print substr(x,5,2) "/" substr(x,7,2) "/" substr(x,1,4) " " substr(x,9,2) ":" substr(x,11,2) " last, " n " times total"
    }
}
'

tagsawk='
{
    tv=substr($0,index($0,":")+1);
    i=index(tv,"=");
    t=substr(tv,1,i-1);
    v=substr(tv,i+1);
    if (t == "LINK") {
	v="<a href=\"" v "\">" v "</a>";
    }
    print "<tr><td align=right>"t"</td><td>"v"</td></tr>"
}
'

function friendlytitle() {
    sn=` echo "$1" |sed -e 's/\.mp3$//' `
    tf="$sn.t"
#   echo "titlefile $tf"
    if [ -r $tf ]; then
	title=` head -1 $tf |sed -e 's/^N=//' `
	bn=` echo "$sn" |sed -e 's/\/[^/]*$//' `
	an=` echo "$bn" |sed -e 's/\/[^/]*$//' `
	tf="$an.t"
	if [ -r $tf ]; then
	    title="$title<br><em>&nbsp;"` head -1 $tf |sed -e 's/^N=//' `
	    tf="$bn.t"
	    if [ -r $tf ]; then
		title="$title / "` head -1 $tf |sed -e 's/^N=//' `
	    fi
	    title="$title</em>"
	fi
    else
	title="<em>$a</em>"
    fi
    echo $title
}

echo 'Content-type: text/html'
echo ''
echo '<html>'
echo '<META HTTP-EQUIV="Pragma" CONTENT="no-cache">'
echo '<head>'
echo "<title>$BANNER_STRING Track Info</title>"
echo '</head>'
cat $TUNEBOT_ROOT/html/bodypart.html.head
a=` grep "^$1$" $TUNEIX `
if [ "$a" = "" ]; then
    echo "I'm sorry, $REMOTE_ADDR, but I can't let you do that."
    echo "<ul>$1</ul>"
    echo "doesn't seem to be in my database."
    cat $TUNEBOT_ROOT/html/bodypart.html.tail
    echo '</html>'
    exit 0
fi

t=` echo "$1" |sed -e 's/\.mp3$//' `
a=` echo "$t" |sed -e 's:/[^/]*$::' `
r=` echo "$a" |sed -e 's:/[^/]*$::' `

echo "<p><center><font size=+2>Track Information</font></center><p>"

echo "<font size=+2><b>Track:</b></font>"
echo "<ul>"
echo "<table>"
tt=` friendlytitle "$t" `
echo "<tr><td><font size=+1><b>Title:</b></font></td><td>$tt</td></tr>"
echo "<tr><td colspan=2><hr></td></tr>"
echo "<tr><td><font size=+1><b>Path:</b></font></td><td>$t.mp3</td></tr>"
echo "<tr><td colspan=2><hr></td></tr>"
echo "<tr><td><font size=+1><b>Tags:</b></font></td><td>"
echo "<table>"
echo "<tr><th align=right>Tag</th><th align=left>Value</th></tr>"
grep "^$t:" $TUNETAGS \
    |awk "$tagsawk"
echo "</table></td></tr>"
ltp=` grep "^$t.mp3" $QDIR/history |awk "$ltpawk" `
ltr=` grep "^$t.mp3" $QDIR/history |awk "$ltrawk" `
echo "<tr><td colspan=2><hr></td></tr>"
echo "<tr><td><font size=+1><b>Last Played:</b></font></td><td>$ltp</td></tr>"
echo "<tr><td><font size=+1><b>Requested:</b></font></td><td>$ltr</td></tr>"
echo "<tr><td><font size=+1><b>Play It Now:</b></font></td><td><a href=$CGI_BIN_URL/tuneput.cgi?$t.mp3><img border=0 src=\"$HTML_TOP_URL/request.gif\" alt=\"PlayThis\"></a></td></tr>"
echo "<tr><td><font size=+1><b>Sounds Broken:</b></font></td><td><a href=$CGI_BIN_URL/tunefeedback.cgi?BROKE=$t.mp3><img src=$HTML_TOP_URL/cleanup.gif border=0 alt=\"Broken\"></a></td>";
echo "</table>"
echo "</ul>"

echo "<font size=+2><b>Album:</b></font>"
echo "<ul>"
echo "<table>"
tt=` friendlytitle "$a" `
echo "<tr><td><font size=+1><b>Title:</b></font></td><td>$tt</td></tr>"
echo "<tr><td colspan=2><hr></td></tr>"
echo "<tr><td><font size=+1><b>Path:</b></font></td><td>$a</td></tr>"
echo "<tr><td colspan=2><hr></td></tr>"
echo "<tr><td><font size=+1><b>Tags:</b></font></td><td>"
echo "<table>"
echo "<tr><th align=left>Tag</th><th align=left>Value</th></tr>"
grep "^$a:" $TUNETAGS \
    |awk "$tagsawk"
echo "</table></td></tr>"
echo "</table>"
echo "</ul>"

echo "<font size=+2><b>Artist:</b></font>"
echo "<ul>"
echo "<table>"
tt=` friendlytitle "$r" `
echo "<tr><td><font size=+1><b>Title:</b></font></td><td>$tt</td></tr>"
echo "<tr><td colspan=2><hr></td></tr>"
echo "<tr><td><font size=+1><b>Path:</b></font></td><td>$r</td></tr>"
echo "<tr><td colspan=2><hr></td></tr>"
echo "<tr><td><font size=+1><b>Tags:</b></font></td><td>"
echo "<table>"
echo "<tr><th align=left>Tag</th><th align=left>Value</th></tr>"
grep "^$r:" $TUNETAGS \
    |awk "$tagsawk"
echo "</table></td></tr>"

echo "</table>"
echo "</ul>"

cat $TUNEBOT_ROOT/html/bodypart.html.tail
echo '</html>'

exit 0

