#!/bin/sh

if [ "$QUERY_STRING" = "" ]; then
    exec ./tuneq.cgi
fi

TUNEBOT_ROOT=XXX-the-tunebot-install-root
source $TUNEBOT_ROOT/settings
source $CONTROLS

time=` date '+%Y%m%d%H%M' `

ABN=""

case "$QUERY_STRING" in
album=* )
    #
    # put album record into temp file
    #
    f=$QDIR/tuneput$$
    AN=` echo "$QUERY_STRING" |sed -e 's/^album=//' `
    TRX=""
    case "$AN" in
    *:* )
	TRX=` echo "$AN" |sed -e 's/.*://' `
	AN=` echo "$AN" |sed -e 's/:.*//' `
	;;
    esac
    echo "Q=$AN" > $f
    if [ "$TRX" = "" ]; then
	TRX=` grep "^$AN/[^/]*$" $TUNEIX |awk 'NR>1{printf(",")}{printf("%d",NR)}END{print ""}' `
    fi
    if [ "$TRX" != "" ]; then
	echo "TRACKS=$TRX" >> $f
    else
	grep "^$AN/[^:]*:T=" $TUNETAGS |awk '{n=split($0,a,"=");split(a[n],a,":");m+=a[1];s+=a[2]}END{printf("T=%d:%02d\n",m+s/60,s%60)}' >> $f
    fi
    echo "TYPE=ALBUM" >> $f
    echo "HOST=$REMOTE_ADDR" >> $f
    hn=` nslookup $REMOTE_ADDR 2> /dev/null |awk '/Name:/{print $2}' `
    if [ "$hn" = "" ]; then
	hn="$REMOTE_ADDR"
    fi
    echo "HOSTNAME=$hn" >> $f
    echo "AT=$time" >> $f
ABN=` grep "$AN:IXA_ABN" $TUNEBOT_ROOT/tune.autotags |sed -e 's/.*=//' `
    ;;
* )
    if grep "^$QUERY_STRING$" $TUNEIX >/dev/null; then
	#
	# put song record into temp file
	#
	f=$QDIR/tuneput$$
	echo "Q=$QUERY_STRING" > $f
	echo "TYPE=TRACK" >> $f
	echo "HOST=$REMOTE_ADDR" >> $f
	hn=` nslookup $REMOTE_ADDR 2> /dev/null |awk '/Name:/{print $2}' `
	if [ "$hn" = "" ]; then
	    hn="$REMOTE_ADDR"
	fi
	echo "HOSTNAME=$hn" >> $f
	echo "AT=$time" >> $f
AN=` echo "$QUERY_STRING" | sed -e 's/\/[^/]*$//' `
ABN=` grep "$AN:IXA_ABN" $TUNEBOT_ROOT/tune.autotags |sed -e 's/.*=//' `
    else
	echo 'Content-type: text/html'
	echo ''
	echo '<html>'
	echo '<head>'
	echo '</head>'
	cat $TUNEBOT_ROOT/html/bodypart.html.head
	echo "I'm sorry, I afraid I can't play the tune $QUERY_STRING."
	echo "<br>This can only be attributed to human error."
	cat $TUNEBOT_ROOT/html/bodypart.html.tail
	echo '</html>'
	exit 0
    fi
    ;;
esac

#
# find the likely next id to put in the queue
#
n=` echo $QDIR/[0-9]* |tr ' ' '\012' |sed -e 's/.*\///' |sort -n |tail -1 `
if [ "$n" = "[0-9]*" ]; then
    n=1
else
    n=` expr $n + 1 `
fi

#
# insert the temp file into the queue
#
#n=1
i=1
while [ $i = 1 ]; do
    #echo "trying to add at $n"
    mv -i $f $QDIR/$n </dev/null >/dev/null 2>&1
    if [ -r $f ]; then
	n=` expr $n + 1 `
    else
	i=0
    fi
done
d=` date '+%Y%m%d%H%M' `
echo "DATE=$d HOST=$REMOTE_ADDR REQUEST=$QUERY_STRING" >> $TUNEBOT_ROOT/feedback

# poke tunebot in case it's asleep
echo poke > /tmp/jobctl

echo 'Content-type: text/html'
echo ''
echo '<html>'
echo '<head>'
if [ "x$PUT_BACK_INDEX" != x1 ]; then
    ABN=""
fi
if [ "x$ABN" = x ]; then
    echo '<META HTTP-EQUIV=REFRESH CONTENT="1; URL=tuneq.cgi">'
else
    echo "<META HTTP-EQUIV=REFRESH CONTENT=\"0; URL=dynindex.cgi?abn=$ABN\">"
fi
echo '</head>'
cat $TUNEBOT_ROOT/html/bodypart.html.head
echo '<center>Okeydoke, added request.</center>'
echo '<p>'
echo '<center>(click <a href="tuneq.cgi">here</a> if play list doesn'"'"'t load automagically)</center>'
cat $TUNEBOT_ROOT/html/bodypart.html.tail
echo '</html>'
exit 0

